<?php
/**
 * Created by PhpStorm.
 * User: rafaelpickbrenne
 * Date: 11/07/14
 * Time: 09:16
 */

namespace Folha\Facade\Relatorios;

class relatoriosFolha {
    //Constantes para os lits dos relatórios
    const rlMen = 'RELATORIO_MENSAL';   //
    const rlGGe = 'RELATORIO_GERENCIAL_GERAL';
    const rlGVi = 'RELATORIO_GERENCIAL_VINCULO';
    //Constantes para os nomes do Fieldgroups
    const fgMen = 'hrm_relatorio_nome_mensal';
    const fgGer = 'hrm_relatorio_nome_gerencial';
    //Constantes para os nomes dos fields.
    const nrOrg_ = 'NRORG';             //Constantes com '_' representam fields que não serão afetados pela visibilidade...
    const compe_ = 'MESCOMPETENCIA';    //...e se é requerido ou não. São usados apenas para leitura neste facade.
    const moCal_ = 'MODALIDCAL'; //Na tela é exibido o campo MODALIDCAL_NOME, mas usa-se este para os relatórios.
    const moSal_ = 'MODALIDSAL'; //todo Modalidade de salário está exibindo o nome também (como o madalidade de cálculo). Se necessário fazer o mesmo que feito no Modalidade de Cálculo
    const ocorr_ = 'OCORRECAL';
    const cdOpe_ = 'CDOPERADOR';
    const nmOpe_ = 'NMOPERADOR';
    const confi_ = 'CONFIDENCIAL';
    const vincu    = 'NRVINCULO';
    const tpVin = 'TIPOVINCULO';
    const tpVi2 = 'TIPOVINCULO_MULT';
    const situa = 'SITUACAO';
    const ocupa = 'OCUPACAO';
    const esLeg = 'ESTRUTLEGAL';
    const esGer = 'ESTRUTGEREN';
    const movim = 'MOVIMENTO';
    const movpr = 'MOVIMENTO_PROV'; //todo talvez mudar de nome ou excluir. Sem uso no momento.
    const dtIni = 'DATAINICIO';
    const dtFim = 'DATAFINAL';
    const peRes = 'PESSOARESP';
    const esRes = 'ESTRUTRESP';
    const estru = 'ESTRUTURA';
    const tpEst = 'TIPOESTRUTURA';
    const dtAno = 'ANOCOMPETENCIA';
    const event = 'EVENTO';
    const grupo = 'GRUPO';
    const nrCa1 = 'NRCALCULO1';
    const nrCa2 = 'NRCALCULO2';
    const omVin = 'OMITIRVINCULOS';
    const omGer = 'OMITIRGEREN';
    const omLeg = 'OMITIRLEGAL';
    const demit = 'INC_DEMITIDO';
    const soDem = 'VINCULOSDEMI';
    const zebra = 'ZEBRADO';
    //MultiSearch's
    const vincList = 'NRVINCULOM_LISTA'; //Lista de vínculos

    //Constantes para as mensagens
    //Mensagem que alerta a falta de seleção de um relatório
    const msgSelRel = 'hrm_relatorio_folha_selecao';
    //Mensagem que alerta da não necessidade de se eselecionar mais de um parâmetro entre vínculo e estruturas legal e gerencial
    const msgMulEst = 'hrm_relatorio_folha_multipla';
    //Mensagem de erro da falta de preechimento de campos obrigatórios
    const msgFalPre = 'hrm_relatorio_folha_preencher';
    //Mensagem nome do relatório inválido ou o mesmo não está integrado
    const msgNomInv = 'hrm_relatorio_folha_nome_relatorio';
    //Mensagem de ausência de manual de relatório
    const msgSemMan = 'hrm_relatorio_folha_sem_manual';
    //Mensagem de alerta de relatório não disponível para a organização em questão
    const msgSemRel = 'hrm_relatorio_folha_sem_relatorio';

    private $nomeRelatorio;     //Nome do relatório
    private $nrOrganizacao;     //Número da organização
    private $cdOperador;        //Código do Operador

    //Array dos campos (não multisearch) que podem ser setados para visíveis, invisíveis, requeridos ou não requeridos.
    private $campos = array(self::vincu, self::tpVin, self::tpVi2, self::situa, self::ocupa, self::esLeg, self::esGer,
        self::movim, self::movpr, self::dtIni, self::dtFim, self::peRes, self::esRes, self::estru, self::tpEst,
        self::dtAno, self::event, self::grupo, self::nrCa1, self::nrCa2, self::omVin, self::omGer, self::omLeg,
        self::demit, self::soDem, self::zebra);

    //Array dos campos exclusivamente multisearch que podem ser setados para visíveis, invisíveis, requeridos ou não requeridos.
    private $multis = array(self::vincList);

    //Array de RESET dos labels dos campos alterados (tando normal quanto multisearch). IMPORTANTE registrar os labels originais dos campos alterados
    private $labels = array(self::dtIni=>'Data Inicial', self::dtFim=>'Data Final', self::event=>'Evento',
        self::estru=>'Estrutura', self::tpEst=>'Tipo de Estrutura', self::esLeg=>'Estrutura Legal',
        self::omVin=>'Omitir Vínculos', self::demit=>'Incluir Vínculos Demitidos', self::situa=>'Situação Funcional',
        self::vincList=>'Vínculo', self::vincu=>'Vínculo');

    //Array com os relatórios e suas configurações
    private $relatorios = array(
        'demonstrativo_pagamento_laser'=>array(
            'requer'=>array(self::movim),
            'parame'=>array(self::event=>'P_EVENTO',/*self::vincu=>'P_NRVINCULO',*/self::esLeg=>'P_NRESTRUTURA',self::esGer=>'P_NRESTRUTGEREN',self::zebra=>'ZEBRADO',self::movim=>'P_NRTIPOMOVIMENT',self::nrOrg_=>'P_NRORG',self::compe_=>'P_DTMESCOMPETENC',self::moCal_=>'P_NRTPMODALIDCAL',self::confi_=>'P_CONFIDENCIAL',self::ocorr_=>'P_OCORRECAL'),
            'multis'=>array(self::vincList=>'P_NRVINCULO'),
            'rotulo'=>array(self::event=>'Apenas Recibos de Pagamentos com este evento:'),
            'manual'=>"<strong>Demonstrativo Pagamento (Laser, duas vias)</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite o demonstrativo de pagamento para impressoras laser (ou similares) em papel A4. Este relatório exibi o demonstrativo em duas vias na mesma página. Pode-se gerar este relatório (demonstrativo de pagamento) para um ou todos vínculos segundo escopo definido via estrutura legal. Este considera o tipo de movimento informado pelo usuário e a modalidade de cálculo parâmetrizada.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, dados salariais, escala de trabalho, dados sobre a ocupação e um ou mais cálculos do movimento selecionado pelo usuário na modalidade (cenário) parametrizado pelo usuário." ),
        'demonstrativo_pagamento_laser_via_unica'=>array(
            'requer'=>array(self::movim),
            'parame'=>array(self::event=>'P_EVENTO',self::esLeg=>'P_NRESTRUTLEGAL',self::esGer=>'P_NRESTRUTGEREN',self::movim=>'P_NRTIPOMOVIMENT',self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::moCal_=>'P_NRTPMODALIDCAL',self::confi_=>'P_CONFIDENCIAL',self::ocorr_=>'P_OCORRECAL'),
            'multis'=>array(self::vincList=>'P_NRVINCULO'),
            'rotulo'=>array(self::event=>'Apenas Recibos de Pagamentos com este evento:'),
            'manual'=>"<strong>Demonstrativo Pagamento (Laser, via única)</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite o demonstrativo de pagamento para impressoras laser (ou similares) em papel A4. Este relatório exibi o demonstrativo em uma via. Pode-se gerar este relatório (demonstrativo de pagamento) para um ou todos vínculos segundo escopo definido via estrutura legal ou gerencial e por um único vínculo. Este considera o tipo de movimento informado pelo usuário e a modalidade de cálculo parâmetrizada.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, dados salariais, escala de trabalho, dados sobre a ocupação e um ou mais cálculos do movimento selecionado pelo usuário na modalidade (cenário) parametrizado pelo usuário." ),
        'demonstrativo_pagamento_lab02'=>array(
            'requer'=>array(self::movim),
            'parame'=>array(self::event=>'P_EVENTO',self::esLeg=>'P_NRESTRUTURA',self::zebra=>'ZEBRADO',self::movim=>'P_NRTIPOMOVIMENT',self::nrOrg_=>'P_NRORG',self::compe_=>'P_DTMESCOMPETENC',self::moCal_=>'P_NRTPMODALIDCAL',self::confi_=>'P_CONFIDENCIAL'),
            'multis'=>array(self::vincList=>'P_NRVINCULO'),
            'rotulo'=>array(self::event=>'Apenas Recibos de Pagamentos com este evento:'),
            'manual'=>"<strong>Demonstrativo Pagamento (Lab02)</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite o demonstrativo de pagamento para formulário contínuo do tipo LAB02. Pode-se gerar este relatório (demonstrativo de pagamento) para um ou todos vínculos segundo escopo definido via estrutura legal. Este considera o tipo de movimento e a modalidade de cálculo informados pelo usuário. Recomenda-se o uso de impressora matricial com tracionador de formulário contínuo para este relatório.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, dados salariais, escala de trabalho, dados sobre a ocupação e um ou mais cálculos do movimento selecionado pelo usuário na modalidade (cenário) também selecionado pelo usuário." ),
        'eventos_relacionados_vinculo' =>array( /*relatório alterado 05/08/14 pck */
            'requer'=>null, //'requer'=>array(self::event),
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::demit=>'P_INCLUIRDEMITIDO',self::esGer=>'P_ESTRUTGEREN',self::esLeg=>'P_ESTRUTLEGAL',self::confi_=>'P_CONFIDENCIAL',self::zebra=>'ZEBRADO',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'), //original 'parame'=>array(self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTURALEGAL',self::esGer=>'P_ESTRUTURAGEREN',self::event=>'P_NREVENTO',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::ocorr_=>'P_OCORRECAL',self::moCal_=>'P_MODALIDADECAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::confi_=>'P_CONFIDENCIAL'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>null,
            'manual'=>"<strong>Eventos Relacionados do Vínculo</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem resumida de um determinado evento definido pelo usuário de um ou todos os vínculos em um escopo definido pela estrutura legal ou gerencial em um tipo de movimento e de modalidade de cálculo também definidos pelo usuário. Este relatório subtotaliza os eventos por estrutura gerencial, estrutura legal e por por último totaliza geral todos os eventos listados.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial e pelo menos um ou mais cálculos no tipo de movimento e modalidade de cálculo selecionados pelo usuário." ),
        'ficha_financeira'             =>array(
            'requer'=>array(self::dtAno, self::movim),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::dtAno=>'P_ANOCOMPETENCIA',self::esLeg=>'P_NRESTRUTURA',self::esGer=>'P_NRESTRUTURAGEREN',self::movim=>'P_TIPOMOVIMENTO',self::ocorr_=>'P_OCORRECAL',self::moCal_=>'P_MODALIDADECAL',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'multis'=>array(self::vincList=>'P_NRVINCULO'),
            'rotulo'=>null,
            'manual'=>"<strong>Ficha Financeira</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite a ficha financeira de um ou vários vínculos da organização considerando o movimento mensal  no cenário parametrizado. Também é possível definir o escopo de vínculos a serem relacionados de acordo com a estrutura legal ou gerencial.<p align=\"justify\" style=\"text-indent: 20px;\">É necessário os cálculos de todos os vínculos (pelo menos do escopo escolhido)."),
        'ficha_financeira_migracao'=>array(
            'requer'=>array(self::dtAno),
            'parame'=>array(self::nrOrg_=>'P_NRORG',/*self::compe_=>'P_COMPETENCIA',*/self::dtAno=>'P_ANOCOMPETENCIA',self::esLeg=>'P_NRESTRUTURA',self::esGer=>'P_ESTRUTGEREN',self::ocorr_=>'P_OCORRECAL',self::moCal_=>'P_MODALIDADECAL',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'multis'=>array(self::vincList=>'P_NRVINCULO'),
            'rotulo'=>null,
            'manual'=>null ),
        'ficha_financeira_analitica'=>array(
            'requer'=>array(self::dtAno),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::dtAno=>'P_ANOCOMP',self::esLeg=>'P_NRESTRUTURALEGAL',self::esGer=>'P_NRESTRUTURAGEREN',self::confi_=>'P_CONFIDENCIAL'),
            'multis'=>array(self::vincList=>'P_NRVINCULOM'),
            'rotulo'=>null,
            'manual'=>"<strong>Ficha Financeira Analítica</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite a ficha financeira da organização de um ano inteiro. Seu layout mostra em forma de quadros com os dados de cada mês do ano especificado. São considerados apenas movimentos mensais no cenário real.</p><p align=\"justify\" style=\"text-indent: 20px;\">É necessário os cálculos de todos os vínculos (pelo menos do escopo escolhido).</p><p align=\"justify\" style=\"text-indent: 20px;\">Este relatório apenas lista os meses em que houveram alguma movimentação financeira no ano informado.</p>" ),
        'ficha_financeira_grade'       =>array(
            'requer'=>array(self::movim, self::dtIni, self::dtFim),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::event=>'P_NREVENTO',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::dtIni=>'P_INICIO',self::dtFim=>'P_FIM',self::movim=>'P_NRTPMOVIMENT',self::ocorr_=>'P_OCORRECAL',self::moCal_=>'P_NRTPMODALIDCAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::confi_=>'P_CONFIDENCIAL'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>array(self::dtIni=>'Período - Mês inicial', self::dtFim=>'Período - Mês final'),
            'manual'=>"<strong>Ficha Financeira em Grade</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite a ficha financeira de um ou vários vínculos da organização em formato de grade totalizando por evento. Pode-se listar apenas um evento ou todos os eventos do(s) vínculo(s). Também é possível definir o escopo de vínculos a serem relacionados de acordo com a estrutura legal ou gerencial.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, dados salariais, escala de trabalho, ocupação, dados de aquisição e gozo de férias, ocupação, situação funcional e pelo menos um mais cálculos de movimentos mensal, adiantamento, 13º salário, etc." ),
        'folha_analitica'              =>array(
            'requer'=>array(self::movim),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::esLeg=>'P_ESTRUTURALEGAL',self::esGer=>'P_ESTRUTURAGEREN',self::zebra=>'ZEBRADO',self::movim=>'P_TIPOMOVIMENTO',self::ocorr_=>'P_OCORRECAL',self::moCal_=>'P_MODALIDADECAL',self::confi_=>'P_CONFIDENCIAL',self::demit=>'P_QUEBRARPAG',self::omVin=>'P_OMITIRVINCULOS',self::omLeg=>'P_OMITIRLEGAL',self::omGer=>'P_OMITIRGERENCIAL',self::soDem=>'P_SODEMITIDO'),
            'multis'=>null,
            'rotulo'=>array(self::demit=>'Quebrar página por Gerencial'),
            'manual'=>"<strong>Folha Analítica</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite a folha analítica de todos os vínculos da organização ou de acordo com o escopo selecionado. Este relatório lista todos os eventos dos vínculos. É possível definir o escopo de vínculos a serem relacionados e totalizados de acordo com a estrutura legal ou gerencial.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, dados salariais, escala de trabalho, dados sobre a ocupação, dados de aquisição e gozo de férias, situação funcional e pelo menos um ou mais cálculos de movimentos mensal, adiantamento, 13º salário, etc." ),
        'folha_analitica_por_tipo_vinculo'=>array(
            'requer'=>array(self::movim, self::tpVi2),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::esLeg=>'P_ESTRUTURALEGAL',self::esGer=>'P_ESTRUTURAGEREN',self::zebra=>'ZEBRADO',self::movim=>'P_TIPOMOVIMENTO',self::tpVi2=>'P_TIPOVINCULO',self::ocorr_=>'P_OCORRECAL',self::moCal_=>'P_MODALIDADECAL',self::confi_=>'P_CONFIDENCIAL',self::soDem=>'P_SODEMITIDO'),
            'multis'=>null,
            'rotulo'=>null,
            'manual'=>"<strong>Folha Analítica por Tipo de Vínculo</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite a folha analítica de todos os vínculos da organização ou de acordo com o escopo selecionado. Este relatório lista todos os eventos dos vínculos. É possível definir o escopo de vínculos a serem relacionados e totalizados de acordo com o tipo do vínculo.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, dados salariais, escala de trabalho, dados sobre a ocupação, dados de aquisição e gozo de férias, situação funcional e pelo menos um ou mais cálculos de movimentos mensal, adiantamento, 13º salário, etc." ),
        'folha_analitica_sintetico'=>array(
            'requer'=>array(self::movim),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::esLeg=>'P_ESTRUTURALEGAL',self::esGer=>'P_ESTRUTURAGEREN',self::zebra=>'ZEBRADO',self::movim=>'P_TIPOMOVIMENTO',self::ocorr_=>'P_OCORRECAL',self::moCal_=>'P_MODALIDADECAL',self::confi_=>'P_CONFIDENCIAL',self::omVin=>'P_OMITIRVINCULOS',self::soDem=>'P_SODEMITIDO'),
            'multis'=>null,
            'rotulo'=>null,
            'manual'=>null ),
        'lancamentos_evento_vinculo'   =>array(
            'requer'=>array(self::event, self::movim),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::event=>'P_NREVENTO',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::movim=>'P_TIPOMOVIMENTO',self::ocorr_=>'P_OCORRECAL',self::moCal_=>'P_MODALIDADECAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::confi_=>'P_CONFIDENCIAL',self::omVin=>'P_INCLUIRZEROS'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>array(self::omVin=>'Incluir eventos zerados'),
            'manual'=>null ), //'manual'=>"<strong>Lançamentos de Eventos por Vínculo</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem completa de um determinado evento definido pelo usuário de um ou todos os vínculos em um escopo definido pela estrutura legal ou gerencial em um tipo de movimento e de modalidade de cálculo também definidos pelo usuário. Este relatório subtotaliza os valores dos eventos e quantidades de funcionários por estrutura gerencial, estrutura legal e por por último totaliza geral todos os eventos listados.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial e pelo menos um ou mais cálculos no tipo de movimento e modalidade de cálculo selecionados pelo usuário." ),
        'lancamentos_evento_vinculo_por_sindicato'=>array( /*novo 05/08/14 pck*/
            'requer'=>array(self::event, self::movim),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::event=>'P_NREVENTO',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::movim=>'P_TIPOMOVIMENTO',self::ocorr_=>'P_OCORRECAL',self::moCal_=>'P_MODALIDADECAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::confi_=>'P_CONFIDENCIAL',self::omVin=>'P_INCLUIRZEROS'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>array(self::omVin=>'Incluir eventos zerados'),
            'manual'=>"<strong>Laçamentos de Eventos por Vínculo – Agrupado por Sindicato</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem completa de um determinado evento definido pelo usuário de um ou de todos os vínculos em um escopo definido pela estrutura legal ou gerencial em um tipo de movimento e de modalidade de cálculo também definidos pelo usuário. Este relatório subtotaliza os valores dos eventos e quantidades de funcionários por sindicato e por último um total geral de todos os eventos listados.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial e pelo menos um ou mais cálculos no tipo de movimento e modalidade de cálculo selecionados pelo usuário." ),
        'liquidocaixa'                 =>array(
            'requer'=>array(self::movim, self::event),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_DTMESCOMPETENC',self::esLeg=>'P_NRESTRUTURA',self::esGer=>'P_NRESTRUTURAGEREN',self::event=>'P_NREVENTO',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::movim=>'P_NRTPMOVIMENT',self::moCal_=>'P_NRTPMODALIDCAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::confi_=>'P_CONFIDENCIAL',self::omVin=>'P_OMITIRVINC',self::ocorr_=>'P_OCORRECAL'),
            'multis'=>null,
            'rotulo'=>array(self::event=>'Evento do líquido (Ex.: 3030, 3040, 3050, etc.)'),
            'manual'=>"<strong>Líquidos Caixa</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite um demonstrativo do valor líquido recebido por cada vínculo que não possui conta bancária em um escopo definido pela estrutura legal ou gerencial, sendo que o valor líquido é um evento informado pelo usuário em um tipo de movimento (mensal, adiantamento, 13º salário, etc.) informado pelo usuário e a modalidade de cálculo (cenário) parametrizada. Também são exibidos informações básicas do vínculo.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, dados salariais, escala de trabalho, dados sobre a ocupação, dados de aquisição e gozo de férias, situação funcional e pelo menos um ou mais cálculos no tipo de movimento e modalidade de cálculo selecionados pelo usuário." ),
        'liquidobanco'                 =>array(
            'requer'=>array(self::movim, self::event),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_DTMESCOMPETENC',self::esLeg=>'P_NRESTRUTURA',self::esGer=>'P_NRESTRUTURAGEREN',self::event=>'P_NREVENTO',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::movim=>'P_NRTPMOVIMENT',self::moCal_=>'P_NRTPMODALIDCAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::confi_=>'P_CONFIDENCIAL',self::omVin=>'P_OMITIRVINC',self::ocorr_=>'P_OCORRECAL'),
            'multis'=>null,
            'rotulo'=>array(self::event=>'Evento do líquido (Ex.: 3030, 3040, 3050, etc.)'),
            'manual'=>"<strong>Líquidos do Banco</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite um demonstrativo do valor líquido recebido por cada vínculo que possui conta bancária em um escopo definido pela estrutura legal ou gerencial, sendo que o valor líquido é um evento informado pelo usuário em um tipo de movimento (mensal, adiantamento, 13º salário, etc.) informado pelo usuário e a modalidade de cálculo (cenário) parametrizada. Também são exibidos informações básicas do vínculo.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, dados salariais, escala de trabalho, dados sobre a ocupação, dados de aquisição e gozo de férias, situação funcional, dados bancários e pelo menos um ou mais cálculos no tipo de movimento e modalidade de cálculo selecionados pelo usuário." ),
        'liquidobanco_por_banco'       =>array(
            'requer'=>array(self::movim, self::event),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_DTMESCOMPETENC',self::esLeg=>'P_NRESTRUTURA',self::esGer=>'P_NRESTRUTURAGEREN',self::event=>'P_NREVENTO',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::movim=>'P_NRTPMOVIMENT',self::moCal_=>'P_NRTPMODALIDCAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::confi_=>'P_CONFIDENCIAL',self::omVin=>'P_OMITIRVINC',self::ocorr_=>'P_OCORRECAL'),
            'multis'=>null,
            'rotulo'=>array(self::event=>'Evento do líquido (Ex.: 3030, 3040, 3050, etc.)'),
            'manual'=>"<strong>Líquidos do Banco</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite um demonstrativo do valor líquido recebido por cada vínculo que possui conta bancária em um escopo definido pela estrutura legal ou gerencial, sendo que o valor líquido é um evento informado pelo usuário em um tipo de movimento (mensal, adiantamento, 13º salário, etc.) informado pelo usuário e a modalidade de cálculo (cenário) parametrizada.<p align=\"justify\" style=\"text-indent: 20px;\">Diferentemente do relatório de Líquidos do Banco este exibi as informações agrupadas por Banco e logo após por agência. Também são exibidos informações básicas do vínculo.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, dados salariais, escala de trabalho, dados sobre a ocupação, dados de aquisição e gozo de férias, situação funcional, dados bancários e pelo menos um ou mais cálculos no tipo de movimento e modalidade de cálculo selecionados pelo usuário." ),
        'liquido'                      =>array(
            'requer'=>array(self::movim, self::event),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_DTMESCOMPETENC',self::esLeg=>'P_NRESTRUTURA',self::esGer=>'P_NRESTRUTURAGEREN',self::event=>'P_NREVENTO',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::movim=>'P_NRTPMOVIMENT',self::moCal_=>'P_NRTPMODALIDCAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::confi_=>'P_CONFIDENCIAL',self::omVin=>'P_OMITIRVINC',self::ocorr_=>'P_OCORRECAL'),
            'multis'=>null,
            'rotulo'=>array(self::event=>'Evento do líquido (Ex.: 3030, 3040, 3050, etc.)'),
            'manual'=>"<strong>Líquidos Geral</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite um demonstrativo do valor líquido recebido por cada vínculo em um escopo definido pela estrutura legal ou gerencial, sendo que o valor líquido é um evento informado pelo usuário em um tipo de movimento (mensal, adiantamento, 13º salário, etc.) informado pelo usuário e a modalidade de cálculo (cenário) parametrizada. Também são exibidos informações básicas do vínculo.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, dados salariais, escala de trabalho, dados sobre a ocupação, dados de aquisição e gozo de férias, situação funcional e pelo menos um ou mais cálculos no tipo de movimento e modalidade de cálculo selecionados pelo usuário." ),
        'vinculos_sem_base_fgts'       =>array(
            'requer'=>array(self::movim),
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::moCal_=>'P_NRTPMODALIDCAL',self::movim=>'P_NRTPMOVIMENT',self::ocorr_=>'P_OCORRECAL'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>null,
            'manual'=>null ),
        'resumo_folha'                 =>array(
            'requer'=>array(self::movim),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_DTMESCOMPETENC',self::esLeg=>'P_NRESTRUTLEGAL',self::esGer=>'P_NRESTRUTGEREN',self::zebra=>'ZEBRADO',self::movim=>'P_NRTIPOMOVIMENT',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::confi_=>'P_CONFIDENCIAL'),
            'multis'=>null,
            'rotulo'=>null,
            'manual'=>"<strong>Resumo Folha</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite um resumo onde totaliza e agrupa os valores dos eventos de todos os vínculos da organização de acordo com o tipo de movimento selecionado pelo usuário. Este exibi os dados agrupando-os por estrutura legal e os subtotalizando.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial e pelo menos um ou mais cálculos no tipo de movimento e modalidade de cálculo selecionados/parametrizados pelo usuário." ),
        'resumo_totais_folha'=>array(
            'requer'=>array(self::movim),
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::moCal_=>'P_MODALIDADECAL',self::movim=>'P_TIPOMOVIMENTO',self::ocorr_=>'P_OCORRECAL',self::tpVin=>'P_TIPOVINCULO'),
            'multis'=>null,
            'rotulo'=>null,
            'manual'=>null ),
        'resumo_folha_por_funcionario'=>array(
            'requer'=>array(self::movim),
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::moCal_=>'P_NRTPMODALIDCAL',self::movim=>'P_NRTPMOVIMENT',self::ocorr_=>'P_OCORRECAL',self::tpVin=>'P_TIPOVINCULO'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>null,
            'manual'=>null ),
        'resumo_impostos'=>array(
            'requer'=>array(self::movim),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::moCal_=>'P_MODALIDADECAL',self::ocorr_=>'P_OCORRECAL',self::movim=>'P_TIPOMOVIMENTO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::confi_=>'P_CONFIDENCIAL',self::zebra=>'ZEBRADO',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>null,
            'manual'=>null ),
        'provisao_ferias'=>array(
            'requer'=>null/*array(self::movpr) */,
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::moCal_=>'P_MODALIDADECAL',self::ocorr_=>'P_OCORRECAL',self::esGer=>'P_ESTRUTGEREN',self::esLeg=>'P_ESTRUTLEGAL',self::tpVin=>'P_TIPOVINCULO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>null,
            'manual'=>null ),
        'provisao_13'=>array(
            'requer'=>null,
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::moCal_=>'P_MODALIDADECAL',self::ocorr_=>'P_OCORRECAL',self::esGer=>'P_ESTRUTGEREN',self::esLeg=>'P_ESTRUTLEGAL',self::tpVin=>'P_TIPOVINCULO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>null,
            'manual'=>null ),
        'medias_13'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::moCal_=>'P_MODALIDADE',self::omVin=>'P_MOSTRARSIMUL'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>array(self::omVin=>'Mostrar Simulação de Cálculo de Médias'),
            'manual'=>null ),
        'requerimento_beneficio_incapacidade'=>array(
            'requer'=>array(self::situa, self::dtIni, self::omVin),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::esGer=>'P_ESTRUTGEREN',self::esLeg=>'P_ESTRUTLEGAL',self::confi_=>'P_CONFIDENCIAL',self::situa=>'P_TPAFASTA',self::dtIni=>'P_DTAFASTA',self::omVin=>'P_ATIV_VINC_PREV',self::tpVin=>'P_TPVINCULO'),
            'multis'=>array(self::vincList=>'P_NRVINCULO'),
            'rotulo'=>array(self::situa=>'Tipo de Afastamento (Situação Funcional)', self::dtIni=>'Último dia de Trabalho do Segurado', self::omVin=>'Outra Atividade na Previdência Social'),
            'manual'=>null ),
        'comparacao_calculos_folha'=>array(
            'requer'=>array(self::nrCa1, self::nrCa2),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::nrCa1=>'P_NRCALCULOFOLHA_1',self::nrCa2=>'P_NRCALCULOFOLHA_2',self::zebra=>'ZEBRADO',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'multis'=>null,
            'rotulo'=>null,
            'manual'=>"<strong>Comparação de Cálculos de Folha</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma comparação de todos os eventos gerados entre dois cálculos de folha.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dois ou mais cálculos." ),
        //Arquivos
        'alelo'=>array(
            'requer'=>array(self::dtIni, self::estru, self::esRes, self::peRes, self::event, self::movim),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::dtIni=>'P_DTPAGTO',self::estru=>'P_ESTRUTURA',self::esRes=>'P_ESTRUTRESP',self::peRes=>'P_PESSRESP',self::event=>'P_NREVENTO',self::movim=>'P_TIPOMOVIMENTO',self::moCal_=>'P_MODALIDADECAL',self::ocorr_=>'P_OCORRECAL',self::esGer=>'P_ESTRUTGEREN',self::esLeg=>'P_ESTRUTLEGAL'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>array(self::dtIni=>'Data de Pagamento', self::event=>'Evento do benefício (Vale Refeição \ Alimentação)', self::estru=>'Estrutura da Empresa'),
            'manual'=>null ),
        'alelo_csv'=>array(
            'requer'=>array(self::event, self::movim, self::esLeg),
            'parame'=>array(self::nrOrg_=>'P_NRORG',self::compe_=>'P_COMPETENCIA',self::event=>'P_NREVENTO',self::movim=>'P_TIPOMOVIMENTO',self::moCal_=>'P_MODALIDADECAL',self::ocorr_=>'P_OCORRECAL',self::esGer=>'P_ESTRUTGEREN',self::esLeg=>'P_ESTRUTLEGAL'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>array(self::event=>'Evento do benefício (Vale Refeição \ Alimentação)', self::esLeg=>'Estrutura (Legal) da Empresa'),
            'manual'=>null ),
        //Relatórios Gerenciais - Geral
        'resumo_inss'=>array(
            'requer'=>array(self::grupo, self::ocorr_, self::movim, self::moCal_),
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::moCal_=>'P_NRTPMODALIDCAL',self::movim=>'P_NRTPMOVIMENT',self::ocorr_=>'P_OCORRECAL',self::grupo=>'P_GRUPO'),
            'rotulo'=>null,
            'manual'=>"<strong>Resumo de Contabilização para o INSS</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma lista de todos os eventos que participaram para a geração da guia de INSS do mês de competência parametrizado para o usuário segundo o tipo de modalidade, tipo de movimentação e o grupo de incidência determinados pelo usuário. O grupo de incidência em questão refere-se a um grupo de incidência contendo todos os eventos que participam da contabilização do INSS.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, dados salariais e pelo menos um ou mais cálculos de movimentos mensal, adiantamento, 13º salário, etc no período e tipo de movimentação analisados." ),
        'alteracao_funcional'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::dtIni=>'P_INICIO',self::dtFim=>'P_FINAL',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'rotulo'=>array(self::dtIni=>'Data de Início da Alteração Funcional', self::dtFim=>'Data de Fim da Alteração Funcional'),
            'manual'=>"<strong>Histórico de Alterações Salariais</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem do histórico de alterações salariais agrupadas por vínculos, estrutura gerencial e por último estrutura legal para um vínculo específico ou para todos os vínculos de um escopo definido pela estrutura legal ou gerencial e pelo período que a alteração ocorreu.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial e suas alterações salariais." ),
        'assoc_eventos_vinculo_e'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::vincu=>'P_NRVINCULO',self::dtIni=>'P_INIVIGENCIA',self::dtFim=>'P_FIMVIGENCIA0'),
            'rotulo'=>array(self::dtIni=>'Início da Vigência da Associação', self::dtFim=>'Fim da Vigência da Associação'),
            'manual'=>"<strong>Associação de eventos e vínculos - por eventos</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem onde relaciona os eventos vinculados a um ou todos os vínculos agrupando por evento considerando a vigência dos eventos com o período definido pelo usuário.<p align=\"justify\" style=\"text-indent: 20px;\">É necessário o cadastro das associações de eventos e vínculos." ),
        'assoc_eventos_vinculo_v'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::vincu=>'P_NRVINCULO',self::dtIni=>'P_INIVIGENCIA',self::dtFim=>'P_FIMVIGENCIA0'),
            'rotulo'=>array(self::dtIni=>'Início da Vigência da Associação', self::dtFim=>'Fim da Vigência da Associação'),
            'manual'=>"<strong>Associação de eventos e vínculos - por vínculo</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem onde relaciona os eventos vinculados a um ou todos os vínculos agrupando por estrutura legal considerando a vigência dos eventos com o período definido pelo usuário.<p align=\"justify\" style=\"text-indent: 20px;\">É necessário o cadastro das associações de eventos e vínculos." ),
        'relacao_eventos_estrutura_e_vinculo'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'rotulo'=>null,
            'manual'=>"<strong>Eventos Associados às Estruturas e Vínculos</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem onde relaciona os eventos vinculados aos vínculos (ou a apenas um) e as suas respectivas estruturas agrupando por estrutura gerencial e legal considerando o escopo definido pela estrutura legal ou gerencial.<p align=\"justify\" style=\"text-indent: 20px;\">É necessário o cadastro das associações de eventos e estruturas e também eventos e vínculos." ),
        'evento_zerado_por_vinculo'=>array(
            'requer'=>array(self::moCal_, self::movim),
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::moCal_=>'P_NRTPMODALIDCAL',self::movim=>'P_NRTPMOVIMENT',self::event=>'P_NREVENTO'),
            'rotulo'=>null,
            'manual'=>"<strong>Eventos Zerados ou Negativos do Vínculo</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma relação de eventos com valor zero ou menor que zero de um ou todos os vínculos de um determinado tipo de movimento e modalidade de cálculo agrupados por estrutura gerencial e legal segundo o escopo definido pela estrutura legal ou gerencial.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, ocupação, situação funcional e um ou mais cálculos no tipo de movimento e modalidade selecionadas pelo usuário." ),
        'assoc_estrutura_evento'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::vincu=>'P_NRVINCULO',self::dtIni=>'P_INIVIGENCIA',self::dtFim=>'P_FIMVIGENCIA0'),
            'rotulo'=>array(self::dtIni=>'Início da Vigência da Associação', self::dtFim=>'Fim da Vigência da Associação'),
            'manual'=>"<strong>Associação de eventos com estruturas</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem onde relaciona os eventos vinculados às estruturas agrupando por estruturas considerando a vigência dos eventos com o período definido pelo usuário.<p align=\"justify\" style=\"text-indent: 20px;\">É necessário o cadastro das associações de eventos e estruturas." ),
        'estruturas_tipo_hierarquia'=>array(
            'requer'=>array(self::tpEst),
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::zebra=>'ZEBRADO',self::tpEst=>'P_TIPOESTRUTURA'),
            'rotulo'=>null,
            'manual'=>"<strong>Estruturas por tipo de hierarquia</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem das estruturas do tipo selecionada pelo usuário e suas estruturas imediatamente superiores.<p align=\"justify\" style=\"text-indent: 20px;\">É necessário o cadastro da estrutura hierárquica." ),
        'tomadores'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::omVin=>'OMITIRVINCULOS',self::tpEst=>'P_NRTPTOMADOR',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'rotulo'=>array(self::tpEst=>'Tipo de Estrutura do Tomador'),
            'manual'=>"<strong>Relação de Tomadores</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem dos vínculos e o tomador de sua estrutura agrupadas por estrutura gerencial, tomador e por último estrutura legal para um vínculo específico ou para todos os vínculos de um escopo definido pela estrutura legal ou gerencial.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal, gerencial e tomador." ),
        'turn_over'=>array(
            'requer'=>array(self::tpEst),
            'parame'=>array(self::compe_=>'P_DTMESCOMPETENC',self::nrOrg_=>'P_NRORG',self::zebra=>'ZEBRADO',self::tpEst=>'P_NRTIPOESTRUTURA'),
            'rotulo'=>null,
            'manual'=>"<strong>Turn Over</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite o turn over da empresa. Baseia no tipo de estrutura informado pelo usuário.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo e cálculos." ),
        //Relatórios Gerenciais - Vínculo
        'rateio_funcionarios_grade'=>array(
            'requer'=>array(self::dtIni, self::dtFim, self::moCal_, self::movim, self::grupo, self::tpEst),
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::dtIni=>'P_INICIO',self::dtFim=>'P_FINAL',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::moCal_=>'P_NRTPMODALIDCAL',self::movim=>'P_NRTPMOVIMENT',self::grupo=>'P_GRUPOINCIDE',self::tpEst=>'P_TIPOESTRUTURA',self::ocorr_=>'P_OCORRECAL'),
            'rotulo'=>array(self::dtIni=>'Data de Inicio - Admissão', self::dtFim=>'Data de Fim - Admissão'),
            'manual'=>"<strong>Rateio de Funcionários por Estrutura</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma relação das movimentações dos vínculos entre um tipo de estrutura, determinada pelo usuário, e os valores totais de alguns eventos, também determinados pelo usuário, rateados de acordo com o tempo de permanência dos vínculos nas estruturas. O escopo deste relatório são o período em que ocorreram estas movimentações, estruturas legais e gerenciais do vínculo e filtrar por um vínculo ou todos os vínculos do escopo. Também são considerados o a modalidade de cálculo (cenário) e o tipo de cálculo.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial, dados salariais, escala de trabalho, dados da movimentação e pelo menos um ou mais cálculos de movimentos mensal, adiantamento, 13º salário, etc no período e tipo de movimentação analisados." ),
        'alteracao_salarial'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::vincu=>'P_VINCULO',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::dtIni=>'P_INICIO',self::dtFim=>'P_FINAL',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'rotulo'=>array(self::dtIni=>'Inicio da Alteração Salarial', self::dtFim=>'Fim da Alteração Salarial'),
            'manual'=>"<strong>Histórico de Alterações Salariais</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem do histórico de alterações salariais agrupadas por vínculos, estrutura gerencial e por último estrutura legal para um vínculo específico ou para todos os vínculos de um escopo definido pela estrutura legal ou gerencial e pelo período que a alteração ocorreu.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial e suas alterações salariais." ),
        'funcionarios_admitidos_periodo'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_DTMESCOMPETENC',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_NRESTRUTURA',self::esGer=>'P_NRESTRUTURAGEREN',self::dtIni=>'P_DTINICIAL',self::dtFim=>'P_DTFINAL',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'rotulo'=>array(self::dtIni=>'Inicio da Admissão', self::dtFim=>'Fim da Admissão'),
            'manual'=>"<strong>Funcionários Admitidos por Período</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem dos vínculos com informações sobre sua ocupação agrupadas por estrutura gerencial e por último estrutura legal para todos os vínculos de um escopo definido pela estrutura legal ou gerencial e pelo período em que ocorreu a admissão.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial e dados sobre sua ocupação." ),
        'funcionarios_demitidos_periodo'=>array(
            'requer'=>array(self::dtIni, self::dtFim),
            'parame'=>array(self::compe_=>'P_DTMESCOMPETENC',self::nrOrg_=>'P_NRORG',self::zebra=>'ZEBRADO',self::esLeg=>'P_NRESTRUTURA',self::esGer=>'P_NRESTRUTURAGEREN',self::dtIni=>'P_DTINICIAL',self::dtFim=>'P_DTFINAL',self::confi_=>'P_CONFIDENCIAL'),
            'rotulo'=>array(self::dtIni=>'Inicio da Rescisão', self::dtFim=>'Fim da Rescisão'),
            'manual'=>"<strong>Funcionários Demitidos por Período</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem dos vínculos com informações sobre sua ocupação agrupadas por estrutura gerencial e por último estrutura legal para todos os vínculos de um escopo definido pela estrutura legal ou gerencial e pelo período em que ocorreu a demissão.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial e dados sobre sua ocupação." ),
        'relacao_funcionarios_ativos_mes'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::tpVin=>'P_TIPOVINCULO',self::situa=>'SITUACAO',self::dtIni=>'P_INICIO',self::dtFim=>'P_FINAL',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>array(self::dtIni=>'Inicio da Admissão', self::dtFim=>'Fim da Admissão'),
            'manual'=>null ),
        'relacao_funcionarios_ativos_mes_sintetico'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::tpVin=>'P_TIPOVINCULO',self::situa=>'SITUACAO',self::dtIni=>'P_INICIO',self::dtFim=>'P_FINAL',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'multis'=>array(self::vincList=>'P_VINCULO'),
            'rotulo'=>array(self::dtIni=>'Inicio da Admissão', self::dtFim=>'Fim da Admissão'),
            'manual'=>null ),
        'relacao_funcionarios_ativos_mes_por_sindicato'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::vincu=>'P_VINCULO',self::tpVin=>'P_TIPOVINCULO',self::situa=>'SITUACAO',self::dtIni=>'P_INICIO',self::dtFim=>'P_FINAL',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'rotulo'=>array(self::dtIni=>'Inicio da Admissão', self::dtFim=>'Fim da Admissão'),
            'manual'=>null ),
        'afastados_por_estrutura'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::vincu=>'P_VINCULO',self::situa=>'P_SITUACAO',self::dtIni=>'P_INICIO',self::dtFim=>'P_FINAL',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'rotulo'=>null,
            'manual'=>null ),
        'relacao_funcionario_banco'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR'),
            'rotulo'=>null,
            'manual'=>null ),
        'relacao_funcionario_por_estrutura'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::vincu=>'P_VINCULO',self::ocupa=>'P_OCUPACAO',self::tpVin=>'P_TIPOVINCULO'),
            'rotulo'=>null,
            'manual'=>"<strong>Relação de Funcionários por Estrutura</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem dos vínculos com informações sobre o tipo de vínculo e sua ocupação agrupadas por estrutura gerencial e por último estrutura legal para um vínculo específico ou para todos os vínculos de um escopo definido pela estrutura legal ou gerencial, pelo tipo de vínculo (CLT, estagiário, Sócio, etc.) e sua ocupação.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial e dados sobre sua ocupação." ),
        'relacao_funcionario_por_sindicato'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_COMPETENCIA',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::demit=>'P_INCLUIRDEMITIDO',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL',self::cdOpe_=>'CDOPERADOR',self::nmOpe_=>'NMOPERADOR',self::vincu=>'P_VINCULO'),
            'rotulo'=>null,
            'manual'=>"<strong>Relação de Funcionários por Sindicato</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem dos vínculos agrupadas por estrutura gerencial, estrutura legal e por último sindicato para um vínculo específico ou para todos os vínculos de um escopo definido pela estrutura legal ou gerencial.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal, gerencial e sindical." ),
        'aniversariantes'=>array(
            'requer'=>null,
            'parame'=>array(self::compe_=>'P_MES',self::nrOrg_=>'P_NRORG',self::esLeg=>'P_ESTRUTLEGAL',self::esGer=>'P_ESTRUTGEREN',self::zebra=>'ZEBRADO',self::confi_=>'P_CONFIDENCIAL'),
            'rotulo'=>null,
            'manual'=>"<strong>Aniversariantes do mês</strong><br><br><p align=\"justify\" style=\"text-indent: 20px;\">Emite uma listagem dos vínculos com informações sobre sua ocupação e data de aniversário agrupadas por estrutura gerencial e por último estrutura legal para todos os vínculos de um escopo definido pela estrutura legal ou gerencial e pelo mês informado pelo usuário.<p align=\"justify\" style=\"text-indent: 20px;\">São necessários dados cadastrais do vínculo, suas estruturas legal e gerencial e dados sobre sua ocupação." ),
        /*'nome_do_relatório'=>array(
            'requer'=>null,
            'parame'=>array(null),
            'rotulo'=>null,
            'manual'=>null ),*/
    );

    public function __construct(){       //Construtor
        switch(tk_get_menu_param(0)){   //Captura o nome do arquivo do respectivo list
            case 'mensal':
                $this->nomeRelatorio = tk_get_field_value(self::rlMen);
                break;
            case 'gerencial_geral':
                $this->nomeRelatorio = tk_get_field_value(self::rlGGe);
                break;
            case 'gerencial_vinculo':
                $this->nomeRelatorio = tk_get_field_value(self::rlGVi);
                break;
        }

        $this->nrOrganizacao = tk_get_field_value(self::nrOrg_);
        $this->cdOperador    = tk_get_field_value(self::cdOpe_);
    }

    /*
     * Função de customização. Relatórios que possuem alguma tratativa em específico. Retorna true indicando que a
     * função seguinte (abrirRelatorio) pode continuar a execução normalmente; e retorno false indica que a função
     * seguinte deve abortar a execução.
     */
    private function customizacao($nomeRelatorio, $nrOrg, $parametros){
        switch($nomeRelatorio){
            case 'alelo':
                if($nrOrg != '1007'){   //Somente abre o relatório para a org 1007
                    tk_warning(tk_get_message_by_name(self::msgSemRel));
                    return false;       //Aborta a execução da rotina normal
                }else{
                    str_replace('/',  '', $parametros['P_DTPAGTO']);
                    str_replace('\\', '', $parametros['P_DTPAGTO']);
                    \Folha\Util\Facade::downloadRelatorio($parametros,
                        $this->nomeRelatorio,
                        'tmp_beneficios',
                        'alelo',
                        'txt',
                        $this->nrOrganizacao,
                        $this->cdOperador,
                        'txt',
                        'run',
                        '*',
                        ' ');
                    return false;    //Aborta a execução da rotina normal
                }
                break;
            case 'alelo_csv':
                \Folha\Util\Facade::downloadRelatorio($parametros,
                    $this->nomeRelatorio,
                    'tmp_beneficios',
                    'alelo_csv',
                    'csv',
                    $this->nrOrganizacao,
                    $this->cdOperador);
                return true;    //Continua a execução da rotina normal
                break;
            case 'folha_analitica':
                $omLeg = tk_get_field_value(self::omLeg);   //Captura das opções
                $omGer = tk_get_field_value(self::omGer);
                $omVin = tk_get_field_value(self::omVin);
                if($omLeg == 'S' && $omGer == 'S'){
                    tk_warning('Não se pode omitir os resumos legais e gerenciais simultaneamente.'); //todo Criar um tkMensage para isto
                    return false;
                }
                if(($omLeg == 'S' || $omGer == 'S') && $omVin == 'N'){
                    tk_warning('Na omissão de um resumo (legal ou gerencial), os vínculos, obrigatoriamente, devem estar omitidos.'); //todo Criar um tkMensage para isto
                    return false;
                }
                return true;
                break;
            case 'medias_13':
                if($nrOrg == '1007') {
                    $parametros['P_IGNORAEVENTO'] = '45,105';
                    tk_open_report_from_array($nomeRelatorio, $parametros, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF);
                    return false;
                }
                return true;
                break;
            /*case 'nome_interno_relatorio': //EXEMPLO!!
                //código de customização
                \Folha\Util\Facade::downloadRelatorio($parametros,
                    $this->nomeRelatorio,
                    'tmp_beneficios',
                    'alelo',
                    'txt',
                    $this->nrOrganizacao,
                    $this->cdOperador,
                    'txt',
                    'frameset');
                return true;    //Continua a execução da rotina normal
                return false;   //Aborta a execução da rotina normal
                break;*/
        }
        return true;    //Indica que pode cotinuar a execução
    }

    /*
     * FUNÇÕES PARA USO DA FACADE
     */
    public function setEscopoTela(){ //Seta o label da tab baseado no parâmetro do menu
        $param = tk_get_menu_param(0);  //Captura o parâmetro do menu (apenas o primeiro)
        tk_set_invisible_field(self::rlMen);
        tk_set_invisible_field(self::rlGGe);
        tk_set_invisible_field(self::rlGVi);
        switch($param){
            case 'mensal':
                tk_set_visible_field(self::rlMen);
                break;
            case 'gerencial_geral':
                tk_set_visible_field(self::rlGGe);
                break;
            case 'gerencial_vinculo':
                tk_set_visible_field(self::rlGVi);
                break;
            default:
                tk_warning('Parâmetro do menu invalido ('.$param.').');
        }
        //tk_set_visible_fieldgroup(self::fgMen);
        //tk_set_invisible_fieldgroup(self::fgGer);
    }

    public function montaCampoMultiSearch($nomeCampoMulti){   //Retorna uma string com os nomes dos vínculos selecionados
        $vetor = tk_get_field_value($nomeCampoMulti);

        if($vetor == "N")   //Verifica se 'NENHUM' foi selecionado e aborta a operação com mensagem de erro
            tk_abort('No campo '.$this->labels[$nomeCampoMulti].' selecione um ou mais registros.');

        if($vetor == "A")   //Verifica se 'TODOS' foi selecionado e retorna 'null'
            return '';

        $string = '';
        $count = count($vetor) - 1;

        for($i = 0; $i < $count; ++$i)
            $string .= $vetor[$i]['nrvinculom'].',';
        $string .= $vetor[$count]['nrvinculom'];

        return $string;
    }

    public function mostrarCampos(){ //Mostra os campos necessário para o relatório em questão. Também seta os campos requeridos. Exibe mensagem de erro se o relatório não existir.
        $nome = $this->nomeRelatorio;

        foreach($this->campos as $aux){         //Todos invisíveis, não requeridos e valores reiniciados
            tk_set_invisible_field($aux);       //Invisível
            tk_set_field_not_required($aux);    //Não requerido
            tk_set_field_value($aux, '');       //Limpa valores dos campos
            //tk_set_visible_field($aux);       //Descomentar isto apenas para debug!!!
        }

        foreach($this->multis as $aux){         //Todos invisíveis, não requeridos e valores reiniciados
            tk_set_invisible_field($aux);       //Invisível
            tk_set_field_not_required($aux);    //Não requerido
            tk_set_field_value($aux, 'A');      //Seta o campo para 'Todos'
            tk_clear_multisearch($aux);
            //tk_set_visible_field($aux);       //Descomentar isto apenas para debug!!!
        }

        if($nome == 'inicio' || $nome == null){   //Se não houver seleção este ignora e não executa os demais
            return;
        }

        if(isset($this->relatorios[$nome])){ //Verifica se existe o relatório no array de configuração
            $config = $this->relatorios[$nome];  //Captura os dados apenas do relatório em questão

            if(isset($config['parame']))
                foreach($config['parame'] as $cam => $aux){   //Coloca os campos necessários visíveis ignorando os campos que não devem ser visibilidade alterada
                    if(in_array($cam, $this->campos))           //Somente os campos permissíveis são alterados
                        tk_set_visible_field($cam);
                }

            if(isset($config['multis']))
                foreach($config['multis'] as $cam => $lab)      //Coloca os campos multisearch visíveis
                    tk_set_visible_field($cam);

            if(isset($config['rotulo']))
                foreach($config['rotulo'] as $cam => $lab)      //Seta um novo nome de campo, conforme o relatório exige
                    tk_set_field_label($cam, $lab);

            if(isset($config['requer']))
                foreach($config['requer'] as $aux)              //Coloca os campos necessários requeridos
                    tk_set_field_required($aux);

            if(isset($this->labels))
                foreach($this->labels as $cam => $lab)              //Reseta os nomes de labels
                    tk_set_field_label($cam, $lab);
        } else {
            tk_warning(tk_get_message_by_name(self::msgNomInv, array($nome)));   //Se passar por aqui significa que o nome do relatório é inválido ou o mesmo não está integrado
        }
    }

    public function verificaVincEstrut(){               //Verifica multipla seleção no vínculo e estruturas
        $cont  = tk_get_field_value(self::vincu) != null ? 1 : 0;
        $cont += tk_get_field_value(self::esLeg) != null ? 1 : 0;
        $cont += tk_get_field_value(self::esGer) != null ? 1 : 0;

        if($cont > 1)   //Verifica se há mais de um campo preenchido
            tk_message(tk_get_message_by_name(self::msgMulEst));
    }

    public function abrirRelatorio(){                   //Abre o relatório selecionado
        $nome = $this->nomeRelatorio;
        $config = $this->relatorios[$nome];

        switch($nome){
            case 'inicio':  //Se não foi selecionado um nome de relatório este lança um aviso ao usuário para fazê-lo
            case '':
                tk_warning(tk_get_message_by_name(self::msgSelRel));
                break;

            default:        //Todos os relatórios, inclusive as opções inválidas
                if(isset($config)){ //Verifica se o relatório existe
                    $cont = 0;          //Contador de campos requeridos nulos

                    foreach($config['requer'] as $aux) //Loop para verificar se um campo requerido (definido pelo nome do relatório) está nulo
                        $cont += tk_get_field_value($aux) == null ? 1 : 0;      //Se o campo for nulo incrementa o contador

                    if($cont == 0){         //Verifica se todos os campos marcados como requerido estão preenchidos
                        $param = array();   //Array de parâmetros para a função tk_open_report_from_array abrir o relatório

                        foreach($config['parame'] as $cam => $par)      //Monta o array de parâmetros (sem multisearch's)
                            $param[$par] = tk_get_field_value($cam);
                        foreach($config['multis'] as $cam => $par)      //Monta/completa o array de parâmetros com os valores de campos multisearch's
                            $param[$par] = self::montaCampoMultiSearch(self::vincList);

                        if($this->customizacao($nome, $this->nrOrganizacao, $param)){ //Verifica se existe alguma customização para o relatório em questão e se deve ou não executar o restante do bloco
                            tk_open_report_from_array($nome, $param, \Setforms2\Runtime\Helper\Report\TkBirtReport::FORMAT_PDF, 'frameset', 'birt', null, null, null);
                        }
                    } else {                //Um ou mais campos requeridos não foram preenchidos
                        tk_warning(tk_get_message_by_name(self::msgFalPre));
                    }
                } else {    //Relatório não existe no array de configuração
                    tk_warning(tk_get_message_by_name(self::msgNomInv, array($nome)));
                }
        }
    }

    public function mostrarManual(){    //Exibi o manual do relatório em questão
        switch($this->nomeRelatorio){
            case 'inicio':  //Se não existir um nome de relatório este lança um aviso ao usuário
            case '':
                tk_warning(tk_get_message_by_name(self::msgSelRel));
                break;
            default:        //Todos os relatórios, inclusive as opções inválidas
                if(isset($this->relatorios[$this->nomeRelatorio])){   //Verifica se existe o relatório selecionado
                    if($this->relatorios[$this->nomeRelatorio]['manual'] != null){   //Verifica se existe manula para o relatório selecionado
                        tk_message($this->relatorios[$this->nomeRelatorio]['manual'], 'info', false);
                    }else{
                        tk_warning(tk_get_message_by_name(self::msgSemMan));    //Mensagem de ausência de relatório
                    }
                }else{      //Relatório selecionado inexistente no array de relatórios. Nome inválido.
                    tk_warning(tk_get_message_by_name(self::msgNomInv, array($this->nomeRelatorio)));
                }
        }
    }
}