/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_INCI                                                     */
/* Tabela : INCIDENCIA                                                        */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_INCI'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_INCI
GO

CREATE TRIGGER DTULTATU_INCI
ON INCIDENCIA
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'INCIDENCIA', null, 'NRINCIDENCIA=' + NRINCIDENCIA + ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE INCIDENCIA
      SET DTULTATUINCI = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(INCIDENCIA.IDENTRSAIDIN,0) = ISNULL(INSERTED.IDENTRSAIDIN,0)) AND
            (ISNULL(INCIDENCIA.CDEMPRESA,0)    = ISNULL(INSERTED.CDEMPRESA,0))    AND
            (ISNULL(INCIDENCIA.CDTIPOOPER,0)   = ISNULL(INSERTED.CDTIPOOPER,0))   AND
            (ISNULL(INCIDENCIA.CDIMPOSTO,0)    = ISNULL(INSERTED.CDIMPOSTO,0))    AND
            (ISNULL(INCIDENCIA.CDINSCESTA,0)   = ISNULL(INSERTED.CDINSCESTA,0))   AND
            (ISNULL(INCIDENCIA.CDPRODUTO,0)    = ISNULL(INSERTED.CDPRODUTO,0))    AND
            (ISNULL(INCIDENCIA.CDGRUPOFISC,0)  = ISNULL(INSERTED.CDGRUPOFISC,0))  AND
            (ISNULL(INCIDENCIA.CDFISCAL,0)     = ISNULL(INSERTED.CDFISCAL,0));
   END;
END;
GO

